/*
 * Al-Bhed Language Translator for FFX on PS2
 * Coded by HighT1mes
 * Jan, 16th, 2002
 * Compiled with DJGPP v2.0 using Allegro lib
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define ENG_TO_AL_BHED '1'
#define AL_BHED_TO_ENG '2'

#define TRUE  		1
#define FALSE 		0

#define PRINT_HEADER printf("+-----------------------------------------------------+\n"); \
                     printf("| Al Bhed Translator, Coded by HighT1mes, Version 1.0 |\n"); \
                     printf("+-----------------------------------------------------+\n");

#define MAX_STRING 1000

/* Global Vars */

char english_set[]    = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
char al_bhed_to_eng[] = "YPLTAVKREZGMSHUBXNCDIJFQOW";
char eng_to_al_bhed[] = "EPSTIWKNUVGCLRYBXHMDOFZQAJ";

char temp[MAX_STRING]; /* tsk tsk global return string */

/* Function Prototypes */

char *engl_to_al_bhed(const char *str);
char *al_bhed_to_engl(const char *str);

/* Function Code */

int main()
{
	int i;
	int ret;
	char string[MAX_STRING]; /* phrase can hold up to a 1000 chars */
	char str[MAX_STRING];

	PRINT_HEADER;

	/* get user's option */

	do
	{
		printf("\n Choose a option...\n\n");
	
		printf("\t1. Translate phrase from English to Al-Bhed\n");
		printf("\t2. Translate phrase from Al-Bhed to English\n\n");

		printf(" Enter a choice: ");
		ret = getchar();                /* KINDA BUGGY FUCK IT! C I/O IS A BITCH! */

	} while (ret != '1' && ret != '2');

	getchar(); /* get junk in stdin */

	/* get the input string to translate */

	printf("\n Now type the phrase: ");
	gets(string);

	/* convert string to uppercase to make the phrase case-sensitive */

	for (i = 0; i < strlen(string); i++)
		string[i] = toupper(string[i]);

	/* process the request */

	switch (ret)
	{
		case ENG_TO_AL_BHED: printf("\n Translation: \n\n  ");
			             engl_to_al_bhed(string);
			             break;
		case AL_BHED_TO_ENG: printf("\n Translation: \n\n  ");
				     al_bhed_to_engl(string);
			             break;
		default:             printf(" You entered a invalid option...\n");
			             break;
	}

	return EXIT_SUCCESS;
}

char *engl_to_al_bhed(const char *str)
{
	int i, j;
	int len;
	
	len = strlen(str);
	
	for (i = 0; i < len; i++)
	{
		if (str[i] == '.')
		{
			printf("\n ");
			continue;
		}

		if (str[i] == '*')
		{
			temp[i] = str[i+1];
			printf("%c", temp[i]);
			i++;
			continue;
		}

		if (str[i] == ' ')
		{
			temp[i] = ' ';
			printf("%c", temp[i]);
			continue;
		}

		for (j = 0; j < 26; j++)
		{
			
			if (str[i] == english_set[j])
			{
				temp[i] = al_bhed_to_eng[j];
				printf("%c", temp[i]);
				break;
			}
		}
	}

	return temp;
}

char *al_bhed_to_engl(const char *str)
{
	int i, j;
	int len;
	
	len = strlen(str);
	
	for (i = 0; i < len; i++)
	{
		if (str[i] == '.')
		{
			printf("\n ");
			continue;
		}

		if (str[i] == '*')
		{
			temp[i] = str[i+1];
			printf("%c", temp[i]);
			i++;
			continue;
		}

		if (str[i] == ' ') 
		{
			temp[i] = ' ';
			printf("%c", temp[i]);
			continue;
		}

		for (j = 0; j < 26; j++)
		{
			if (str[i] == al_bhed_to_eng[j])
			{
				temp[i] = english_set[j];
				printf("%c", temp[i]);
				break;
			}
		}
	}

	return temp;
}

/* EOF */